﻿Imports System.Data


Partial Public Class Empleat_BuscaUsuari

    Public Function Existeix() As Boolean
        Dim UsuOk As Boolean = False
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.CercaUsuari(Me.TB_dni.Text)
        xPAServer.Close()
        For Each row As DataRow In dt.Rows
            UsuOk = True
        Next
        Existeix = UsuOk
    End Function
    Public Function Empleat() As Boolean
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.EsEmpleat(Me.TB_dni.Text)
        xPAServer.Close()
        For Each row As DataRow In dt.Rows

            If row(0) > 0 Then
                Empleat = True
            Else
                Empleat = False
            End If
        Next
    End Function

    Private Sub BCancel_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BCancel.Click
        Me.Close()
    End Sub

    Private Sub BAlta_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BAlta.Click
        If Existeix() Then
            MsgBox("L'usuari ja existeix", MsgBoxStyle.Exclamation)
        Else
            Dim finestra As New Empleat_AltaUsuari
            If Trim(TB_dni.Text) <> "" Then
                finestra.TB_idUsuari.Text = Me.TB_dni.Text
            End If
            finestra.Alta = True
            finestra.ShowDialog()
        End If

    End Sub

    Private Sub BBaixa_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BBaixa.Click
        If Existeix() Then
            If Empleat() Then
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim res As Boolean = res = xPAServer.deleteEmpleat(Trim(Me.TB_dni.Text))

                res = xPAServer.deleteUsuari(Trim(Me.TB_dni.Text))
                xPAServer.Close()
                MsgBox("S'ha eliminat l'usuari del sistema")
                'Me.Close()
            Else
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()

                Dim res As Boolean = xPAServer.deleteReservesActClient(Trim(Me.TB_dni.Text))
                res = xPAServer.deletePeticionsClient(Trim(Me.TB_dni.Text))
                res = xPAServer.deleteResRecursosClient(Trim(Me.TB_dni.Text))

                res = xPAServer.deleteClient(Trim(Me.TB_dni.Text))
                'MsgBox(res)
                res = xPAServer.deleteUsuari(Trim(Me.TB_dni.Text))
                'MsgBox(res)
                xPAServer.Close()
                MsgBox("S'ha eliminat l'usuari del sistema")
                'Me.Close()
            End If
        Else
            MsgBox("L'usuari no existeix", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub BMod_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BMod.Click
        If Existeix() Then

            Dim finestra As New Empleat_AltaUsuari
            finestra.TB_idUsuari.Text = Me.TB_dni.Text

            If Empleat() Then
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim dt As DataTable = xPAServer.CercaEmpl(Me.TB_dni.Text)
                xPAServer.Close()

                For Each row As DataRow In dt.Rows
                    finestra.TBNom.Text = row("Nom")
                    finestra.TBCognom1.Text = row("Cognom1")
                    finestra.TBCognom2.Text = row("Cognom2")

                Next
                finestra.CheckBox1.IsChecked = True

                finestra.CheckBox1.IsEnabled = False
                finestra.TBHab.IsEnabled = False
                finestra.TB_idUsuari.IsEnabled = False
              
            Else
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim dt As DataTable = xPAServer.CercaClient(Me.TB_dni.Text)
                xPAServer.Close()

                For Each row As DataRow In dt.Rows
                    finestra.TBNom.Text = row("Nom")
                    finestra.TBCognom1.Text = row("Cognom1")
                    finestra.TBCognom2.Text = row("Cognom2")
                    finestra.TBHab.Text = row("NumHabitacio")
                Next
                finestra.CheckBox1.IsEnabled = False
                finestra.TB_idUsuari.IsEnabled = False

            End If
            finestra.Alta = False
            finestra.ShowDialog()
        Else
            MsgBox("L'usuari no existeix", MsgBoxStyle.Exclamation)
        End If
    End Sub

End Class
