﻿Imports Calendari
Imports System.ComponentModel
Imports System.Data

Partial Public Class Empleat_Calendari
    Dim App As String = ""
    Class Agenda
        Public Tipus As String
        Public Codi As Integer
        Public Data As Date
        Public Hora As TimeSpan
    End Class
    Private _myAppointmentsList As New List(Of Appointment)
    Private _codiAgenda As New List(Of Agenda)
    Private selectedDay As Date
    Public AppProp As Array

    Private Sub Calendari_AppointmentDblClicked(ByVal Appointment_Id As Integer) Handles Calendari.AppointmentDblClicked

        Me.selectedDay = (Me.Calendari.MonthAppointments.Find(Function(apt As Appointment) apt.AppointmentID = Appointment_Id)).StartTime

        App = (Me.Calendari.MonthAppointments.Find(Function(apt As Appointment) apt.AppointmentID = Appointment_Id)).Subject

        'MsgBox(Mid(App, 8))

        AppProp = Split(Trim(Mid(App, 8)), ":")

        'MsgBox("idRec: " & AppProp(0) & " Tipus: " & AppProp(1))

        Select Case Trim(AppProp(1))
            Case "Peticio"
                'MsgBox(CInt(AppProp(0).ToString) & " / " & AppProp(3).ToString & " / " & Me.selectedDay & " / " & TimeSpan.Parse(Mid(Me.App, 1, 5)).ToString)
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim res As Boolean = xPAServer.deletePeticio(CInt(AppProp(0).ToString), Trim(AppProp(3).ToString), Me.selectedDay, TimeSpan.Parse(Mid(Me.App, 1, 5)))
                xPAServer.Close()
                'Me.Close()


            Case "Recurs"
                'MsgBox(CInt(AppProp(0).ToString) & " / " & AppProp(3).ToString & " / " & Me.selectedDay & " / " & TimeSpan.Parse(Mid(Me.App, 1, 5)).ToString)
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim res As Boolean = xPAServer.deleteReservaRecurs(CInt(AppProp(0).ToString), Trim(AppProp(3).ToString), Me.selectedDay, TimeSpan.Parse(Mid(Me.App, 1, 5)))
                xPAServer.Close()
                'Me.Close()

            Case "Activitat"
                'MsgBox(CInt(AppProp(0).ToString) & " / " & AppProp(3).ToString)
                Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
                xPAServer.Open()
                Dim res As Boolean = xPAServer.deleteReservaActivitat(CInt(AppProp(0).ToString), Trim(AppProp(3).ToString))
                xPAServer.Close()
                'Me.Close()
        End Select


        Call carregaAgenda()
        Call SetAppointments()

    End Sub

    Private Sub DisplayMonthChanged(ByVal e As MonthChangedEventArgs) Handles Calendari.DisplayMonthChanged
        Call SetAppointments()
    End Sub
    Private Sub carregaAgenda()
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.getTotsAgenda()
        xPAServer.Close()
        _myAppointmentsList = New List(Of Appointment)
        _codiAgenda = New List(Of Agenda)
        Dim pos As Integer = 1
        For Each row As DataRow In dt.Rows
            Dim _agenda As New Agenda()
            Dim appointment As New Appointment()

            _agenda.Codi = row("Codi")
            _agenda.Tipus = row("Tipus")
            _agenda.Data = row("Data")
            _agenda.Hora = row("Hora")

            Dim startTime As Date = New Date(_agenda.Data.Ticks)

            appointment.AppointmentID = pos
            appointment.StartTime = _agenda.Data
            appointment.EndTime = _agenda.Data
            appointment.Subject = New DateTime(_agenda.Hora.Ticks).ToString("HH:mm") & " - " & row("Codi") & ": " & _agenda.Tipus & ": " & row("Descripcio").ToString() & ": " & row("idUsuari").ToString()
            _myAppointmentsList.Add(appointment)
            pos = pos + 1
        Next
    End Sub
    Private Sub SetAppointments()
       
        Me.Calendari.MonthAppointments = _myAppointmentsList.FindAll( _
                        New System.Predicate(Of Appointment)( _
                        Function(apt As Appointment) _
                            apt.StartTime IsNot Nothing AndAlso _
                            CDate(apt.StartTime).Month = Me.Calendari.DisplayStartDate.Month AndAlso _
                            CDate(apt.StartTime).Year = Me.Calendari.DisplayStartDate.Year))
    End Sub

    Private Sub Empleat_Calendari_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Call carregaAgenda()
        Call SetAppointments()
    End Sub
End Class
