﻿Imports System.Data

Partial Public Class ReservaRecurs
    Private data As Date
    Public dni As String

    Public Sub New(ByVal data As Date)
        Call InitializeComponent()
        Me.data = data
    End Sub


    Private Sub ReservaRecurs_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Me.CB_Recurs.ItemsSource = New DataView(xPAServer.getTotsRecursosOrdenatsPerDescripcio)
        xPAServer.Close()
        If (Me.CB_Recurs.Items.Count > 0) Then
            Me.CB_Recurs.SelectedIndex = 0
        End If

        Me._tbData.Text = Me.data.ToString("d")
        Me.tbData.IsEnabled = False
    End Sub

    Private Sub BCancelar_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BCancelar.Click
        Me.Close()
    End Sub

    Private Sub BResRecurs_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BResRecurs.Click
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.recursDisponible(CInt(CB_Recurs.SelectedItem(0)), Me.data, TimeSpan.Parse((_timePicker.SelectedHour).ToString & ":00"))
        Dim demanat As Integer = 0
        'MsgBox("Aki")
        'xPAServer.Close()
        For Each row As DataRow In dt.Rows
            demanat = CInt(row("quants"))
            'MsgBox(demanat.ToString)
        Next

        If CInt(demanat) > 0 Then
            MsgBox("Recurs no disponible")
            xPAServer.Close()
            Me.Close()

        Else
            'xPAServer.Open()
            'MsgBox("Aki2")
            'MsgBox(TimeSpan.Parse((_timePicker.SelectedHour).ToString & ":00").ToString)
            Dim res As Boolean = xPAServer.addReservaRecurs(CInt(CB_Recurs.SelectedItem(0)), Me.dni, Me.data, TimeSpan.Parse((_timePicker.SelectedHour).ToString & ":00"))
            xPAServer.Close()
            Me.Close()
        End If

    End Sub
End Class
