﻿Imports System.Data
Imports System.Data.Common
Imports System.Configuration

' ---------------------------------------------------------------------------------------------------------
' Definim les funcions que gestionen la connexió amb la base de dades
'----------------------------------------------------------------------------------------------------------
Public MustInherit Class Taula
    Private Shared provider As DbProviderFactory = DbProviderFactories.GetFactory(ConfigurationManager.AppSettings("DATABASE_DRIVER"))
    Private Shared connectionString As String = ConfigurationManager.AppSettings("DATABASE_CONNECTION_STRING")

    Protected MustOverride Function getNomTaula() As String

    Shared Sub Taula()
        provider = DbProviderFactories.GetFactory(ConfigurationManager.AppSettings("DATABASE_DRIVER"))
        connectionString = ConfigurationManager.AppSettings("DATABASE_CONNECTION_STRING")
    End Sub

    Protected Function getDbConnection() As DbConnection
        getDbConnection = provider.CreateConnection()
        getDbConnection.ConnectionString = connectionString
    End Function

    Protected Function getDbCommand() As DbCommand
        getDbCommand = provider.CreateCommand
    End Function

    Protected Function getDbDataAdapter() As DbDataAdapter
        getDbDataAdapter = provider.CreateDataAdapter
    End Function

    Protected Function getDbParameter() As DbParameter
        getDbParameter = provider.CreateParameter
    End Function

End Class
