﻿Imports System.Data

Partial Public Class AltaRecurs
    Protected reload As Boolean = True
    Private Sub BCancel_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BCancel.Click
        Me.Close()
    End Sub

    Private Sub AltaRecurs_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        If Me.TB_Places.Text = "" Then Me.TB_Places.Text = 0
        Me.CB_Recurs.ItemsSource = New DataView(xPAServer.getTotsRecursosOrdenatsPerDescripcio())
        xPAServer.Close()
    End Sub

    Private Sub BAlta_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BAlta.Click
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        If Me.TB_Places.Text = "" Then Me.TB_Places.Text = 0
        Dim res As Boolean = xPAServer.addRecurs(Trim(Me.TBDesc.Text), CInt(Me.TB_Places.Text))
        Me.reload = False
        Me.CB_Recurs.ItemsSource = New DataView(xPAServer.getTotsRecursosOrdenatsPerDescripcio())
        xPAServer.Close()
        Me.TBDesc.Text = ""
    End Sub

    Private Sub BBaixa_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BBaixa.Click
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim res As Boolean = xPAServer.deleteReservesRecurs(CInt(CB_Recurs.SelectedItem(0).ToString))
        res = xPAServer.deleteRecurs(CInt(CB_Recurs.SelectedItem(0).ToString))
        Me.reload = False
        Me.TBDesc.Text = ""
        Me.CB_Recurs.ItemsSource = New DataView(xPAServer.getTotsRecursosOrdenatsPerDescripcio())
        xPAServer.Close()

    End Sub

    Private Sub BMod_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BMod.Click
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        If Me.TB_Places.Text = "" Then Me.TB_Places.Text = 0
        Dim res As Boolean = xPAServer.updateRecurs(CInt(CB_Recurs.SelectedItem(0).ToString), Me.TBDesc.Text, CInt(Me.TB_Places.Text))
        Me.reload = False
        Me.CB_Recurs.ItemsSource = New DataView(xPAServer.getTotsRecursosOrdenatsPerDescripcio())
        xPAServer.Close()
        Me.TBDesc.Text = ""
    End Sub

    Private Sub CB_Recurs_SelectionChanged(ByVal sender As Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles CB_Recurs.SelectionChanged
        Me.TB_Places.Text = 0
        Me.TBDesc.Text = ""
        If reload Then
            Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
            xPAServer.Open()
            Dim dt As DataTable = xPAServer.getRecurs(CInt(CB_Recurs.SelectedItem(0).ToString))
            xPAServer.Close()
            For Each row As DataRow In dt.Rows
                Me.TB_Places.Text = row("NumPlaces")
                Me.TBDesc.Text = row("Descripcio")
            Next
        End If
        reload = True
    End Sub
End Class
