﻿Imports System.Data
Partial Public Class ReservaActivitat
    Public dni As String
    Public Activitat As Integer

    Public Sub New(ByVal Activ As Integer, ByVal _dni As String)
        Call InitializeComponent()
        Me.Activitat = Activ
        Me.dni = _dni
    End Sub
    Private Sub BCancel_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BCancel.Click
        Me.Close()
    End Sub

    Private Sub ReservaActivitat_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.getActivitat(Me.Activitat)
        xPAServer.Close()
        For Each row As DataRow In dt.Rows
            Me.LData.Content = row("Data")
            Me.LDescripcio.Content = row("Descripcio")
            Me.LHora.Content = row("Hora")
            Me.LPlacDisp.Content = row("NumPlaces")
        Next
    End Sub

    Private Sub BResAct_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles BResAct.Click
        Dim places As Integer = CInt(Me.LPlacDisp.Content) - CInt(Me.TB_Places.Text)
        If places < 0 Then
            MsgBox("Ha superat el nombre de places disponibles", MsgBoxStyle.Exclamation)
        Else
            Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
            xPAServer.Open()
            Dim res As Boolean = xPAServer.addReservaActivitat(Me.Activitat, Me.dni, CInt(Me.TB_Places.Text))
            res = xPAServer.updateActPlaces(Me.Activitat, places)
            xPAServer.Close()
        End If
        Me.Close()
    End Sub
End Class
