﻿Imports System.ComponentModel
Imports System.Data
Imports Calendari

Class Window1

    Public dni As String

    Class Agenda
        Public Tipus As String
        Public Codi As Integer
        Public Data As Date
        Public Hora As TimeSpan
    End Class

    Private _myAppointmentsList As New List(Of Appointment)
    Private _codiAgenda As New List(Of Agenda)
    Private selectedDay As Date

    Private Sub Window1_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        'Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        'xPAServer.Open()
        'Me.ComboBox1.ItemsSource = New DataView(xPAServer.getActivitats())
        'xPAServer.getActivitats().IListSource().GetList()
        'xPAServer.Close()
        'Me.ComboBox1.DisplayMemberPath = "Descripcio"
        'Me.ComboBox1.SelectedValuePath = "idActivitat"
        Call carregaAgenda()
        Call SetAppointments()
    End Sub

    Private Sub Calendari_AppointmentDblClicked(ByVal Appointment_Id As Integer) Handles Calendari.AppointmentDblClicked
        'MsgBox(Me.Calendari.MonthAppointments.Item(Appointment_Id - 1).Subject.ToString & "--> " & Appointment_Id)
        'MsgBox((Me.Calendari.MonthAppointments.Find(Function(apt As Appointment) apt.AppointmentID = Appointment_Id)).Subject)
        'Me.selectedDay = e.StartDate

        Me.selectedDay = (Me.Calendari.MonthAppointments.Find(Function(apt As Appointment) apt.AppointmentID = Appointment_Id)).StartTime
        Dim finestra As DeleteReserves
        finestra = New DeleteReserves(Me.selectedDay)
        finestra.dni = Me.dni
        finestra.App = (Me.Calendari.MonthAppointments.Find(Function(apt As Appointment) apt.AppointmentID = Appointment_Id)).Subject
        finestra.ShowDialog()
        Call carregaAgenda()
        Call SetAppointments()

    End Sub

    Private Sub Calendari_DayBoxDoubleClicked(ByVal e As Calendari.NewAppointmentEventArgs) Handles Calendari.DayBoxDoubleClicked
        MsgBox("DayBox")
    End Sub

    Private Sub DisplayMonthChanged(ByVal e As MonthChangedEventArgs) Handles Calendari.DisplayMonthChanged
        Call SetAppointments()
    End Sub


    Private Sub carregaAgenda()
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.getAgendaClient(Me.dni)
        xPAServer.Close()
        _myAppointmentsList = New List(Of Appointment)
        _codiAgenda = New List(Of Agenda)
        Dim pos As Integer = 1
        For Each row As DataRow In dt.Rows
            Dim _agenda As New Agenda()
            Dim appointment As New Appointment()

            _agenda.Codi = row("Codi")
            _agenda.Tipus = row("Tipus")
            _agenda.Data = row("Data")
            _agenda.Hora = row("Hora")

            Dim startTime As Date = New Date(_agenda.Data.Ticks)

            appointment.AppointmentID = pos
            appointment.StartTime = _agenda.Data
            appointment.EndTime = _agenda.Data
            appointment.Subject = New DateTime(_agenda.Hora.Ticks).ToString("HH:mm") & " - " & row("Codi") & ": " & _agenda.Tipus & ": " & row("Descripcio").ToString()
            _myAppointmentsList.Add(appointment)
            pos = pos + 1
        Next
    End Sub

    Private Sub SetAppointments()
        '-- Use whatever function you want to load the MonthAppointments list, I happen to have a list filled by linq that has
        '   many (possibly the past several years) of them loaded, so i filter to only pass the ones showing up in the displayed
        '   month.  Note that the "setter" for MonthAppointments also triggers a redraw of the display.
        Me.Calendari.MonthAppointments = _myAppointmentsList.FindAll( _
                        New System.Predicate(Of Appointment)( _
                        Function(apt As Appointment) _
                            apt.StartTime IsNot Nothing AndAlso _
                            CDate(apt.StartTime).Month = Me.Calendari.DisplayStartDate.Month AndAlso _
                            CDate(apt.StartTime).Year = Me.Calendari.DisplayStartDate.Year))
    End Sub

    Private Sub DayBoxDoubleClicked_event(ByVal e As NewAppointmentEventArgs)
        MessageBox.Show("You double-clicked on day " & CDate(e.StartDate).ToShortDateString(), "Calendar Event", MessageBoxButton.OK)
    End Sub

    Private Sub AppointmentDblClicked(ByVal Appointment_Id As Integer)
        MessageBox.Show("You double-clicked on appointment with ID = " & Appointment_Id, "Calendar Event", MessageBoxButton.OK)
    End Sub

    Private Sub DayBoxRightButtonUp(ByVal e As NewAppointmentEventArgs) Handles Calendari.DayBoxRightButtonUp
        Me.selectedDay = e.StartDate
        Me.Calendari.ContextMenu.IsOpen = True
    End Sub

    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim finestra As ReservaRecurs
        finestra = New ReservaRecurs(Me.selectedDay)
        finestra.dni = Me.dni
        finestra.ShowDialog()
        Call carregaAgenda()
        Call SetAppointments()
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim finestra As NovaPeticio
        finestra = New NovaPeticio(Me.selectedDay)
        finestra.dni = Me.dni
        finestra.ShowDialog()
        Call carregaAgenda()
        Call SetAppointments()
    End Sub
End Class
