﻿Imports Calendari
Imports System.ComponentModel
Imports System.Data

Partial Public Class calActivitats
    Public dni As String
    Public Class Agenda
        Public Desc As String
        Public Codi As Integer
        Public Data As Date
        Public Hora As TimeSpan
    End Class

    Private _myAppointmentsList As New List(Of Appointment)
    Private _codiAgenda As New List(Of Agenda)
    Private selectedDay As Date

    Private Sub Calendari_AppointmentDblClicked(ByVal Appointment_Id As Integer) Handles Calendari.AppointmentDblClicked

        Dim finestra As New ReservaActivitat(Appointment_Id, Me.dni)
        finestra.ShowDialog()
        Call carregaAgenda()
        Call SetAppointments()
    End Sub

    Private Sub Calendari_DayBoxDoubleClicked(ByVal e As Calendari.NewAppointmentEventArgs) Handles Calendari.DayBoxDoubleClicked
        MsgBox(CDate(e.StartDate).ToShortDateString())
    End Sub


    Private Sub DisplayMonthChanged(ByVal e As MonthChangedEventArgs) Handles Calendari.DisplayMonthChanged
        Call SetAppointments()
    End Sub
    Private Sub calActivitats_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Call carregaAgenda()
        Call SetAppointments()
    End Sub


    Private Sub carregaAgenda()
        Dim xPAServer As XPAServerProxy.XPAServerClient = New XPAClient.XPAServerProxy.XPAServerClient()
        xPAServer.Open()
        Dim dt As DataTable = xPAServer.getActivitatsOrdenadesDisponibles()
        xPAServer.Close()
        _myAppointmentsList = New List(Of Appointment)
        _codiAgenda = New List(Of Agenda)
        Dim pos As Integer = 1
        For Each row As DataRow In dt.Rows
            Dim _agenda As New Agenda()
            Dim appointment As New Appointment()
            _agenda.Desc = row("Descripcio")
            _agenda.Codi = row("idActivitat")
            _agenda.Data = row("Data")
            _agenda.Hora = row("Hora")


            Dim startTime As Date = New Date(_agenda.Data.Ticks)

            appointment.AppointmentID = row("idActivitat")
            appointment.StartTime = _agenda.Data
            appointment.EndTime = _agenda.Data
            appointment.Subject = New DateTime(_agenda.Hora.Ticks).ToString("HH:mm") & " - " & row("NumPlaces").ToString() & ": " & row("Descripcio").ToString()
            _myAppointmentsList.Add(appointment)
            'pos = pos + 1
        Next
    End Sub
    Private Sub SetAppointments()
        Me.Calendari.MonthAppointments = _myAppointmentsList.FindAll( _
                        New System.Predicate(Of Appointment)( _
                        Function(apt As Appointment) _
                            apt.StartTime IsNot Nothing AndAlso _
                            CDate(apt.StartTime).Month = Me.Calendari.DisplayStartDate.Month AndAlso _
                            CDate(apt.StartTime).Year = Me.Calendari.DisplayStartDate.Year))
    End Sub
    Private Sub DayBoxDoubleClicked_event(ByVal e As NewAppointmentEventArgs)
    End Sub
    Private Sub AppointmentDblClicked(ByVal Appointment_Id As Integer)

    End Sub

End Class
