﻿' NOTA: si cambia aquí el nombre de interfaz "IService1", también debe actualizar la referencia a "IService1" en Web.config.
<ServiceContract()> _
Public Interface IXPAServer

    ' ---------------------------------------------------------------------------------------------------------
    ' A la interficie definim el contracte.
    ' Definim els prototipus de les funcions que seràn accessibles des de làplicació client
    '----------------------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function getActivitats() As DataTable
    <OperationContract()> _
    Function addActivitat(ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function deleteActivitat(ByVal idActividad As Integer) As Boolean
    <OperationContract()> _
    Function updateActivitat(ByVal idActividad As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function getTotsAgenda() As DataTable
    <OperationContract()> _
    Function addReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function getTotsRecursosOrdenatsPerDescripcio() As DataTable
    <OperationContract()> _
    Function getTotsServeisOrdenatsPerDescripcio() As DataTable
    <OperationContract()> _
    Function cercaClients(ByVal nom As String, ByVal cognom1 As String, ByVal cognom2 As String, ByVal idclient As String) As DataTable
    <OperationContract()> _
    Function CercaUsuari(ByVal idUsuari As String) As DataTable
    <OperationContract()> _
    Function getAgendaClient(ByVal idUsuari As String) As DataTable
    <OperationContract()> _
    Function getActivitatsOrdenadesDisponibles() As DataTable
    <OperationContract()> _
    Function getActivitat(ByVal idActivitat) As DataTable
    <OperationContract()> _
    Function addReservaActivitat(ByVal Activitat As Integer, ByVal Client As String, ByVal Places As Integer) As Boolean
    <OperationContract()> _
    Function updateActPlaces(ByVal idActividad As Integer, ByVal NumPlaces As Integer) As Boolean
    <OperationContract()> _
    Function addPeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function deleteReservaActivitat(ByVal Activitat As Integer, ByVal Client As String) As Boolean
    <OperationContract()> _
    Function deleteReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function deletePeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
    <OperationContract()> _
    Function EsEmpleat(ByVal idUsuari As String) As DataTable
    <OperationContract()> _
    Function getTotsUsuarisOrdenatsPerCognom() As DataTable
    <OperationContract()> _
    Function CercaClient(ByVal idUsuari As String) As DataTable
    <OperationContract()> _
    Function CercaEmpl(ByVal idUsuari As String) As DataTable



    <OperationContract()> _
    Function addClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer, ByVal Data As Date) As Boolean
    <OperationContract()> _
    Function addUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean
    <OperationContract()> _
    Function deleteClient(ByVal idUsuari As String) As Boolean
    <OperationContract()> _
    Function deleteUsuari(ByVal idUsuari As String) As Boolean
    <OperationContract()> _
    Function deleteEmpleat(ByVal idUsuari As String) As Boolean
    <OperationContract()> _
    Function addEmpleat(ByVal idUsuari As String) As Boolean
    <OperationContract()> _
    Function updateUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean
    <OperationContract()> _
    Function updateClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer) As Boolean
    <OperationContract()> _
    Function addServei(ByVal Descripcio As String) As Boolean
    <OperationContract()> _
    Function deleteServei(ByVal idServei As Integer) As Boolean
    <OperationContract()> _
    Function updateServei(ByVal idServei As Integer, ByVal Descripcio As String) As Boolean


    <OperationContract()> _
    Function addRecurs(ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean
    <OperationContract()> _
    Function deleteRecurs(ByVal idRecurs As Integer) As Boolean
    <OperationContract()> _
    Function updateRecurs(ByVal idRecurs As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean
    <OperationContract()> _
    Function getRecurs(ByVal idRecurs As Integer) As DataTable

    <OperationContract()> _
    Function deleteResActRelacionades(ByVal Activitat As Integer) As Boolean
    <OperationContract()> _
    Function deleteReservesActClient(ByVal Client As String) As Boolean
    <OperationContract()> _
    Function deleteResRecursosClient(ByVal Client As String) As Boolean
    <OperationContract()> _
    Function deleteReservesRecurs(ByVal Recurs As Integer) As Boolean
    <OperationContract()> _
    Function deletePeticionsClient(ByVal Client As String) As Boolean
    <OperationContract()> _
    Function deletePeticionsServei(ByVal Servei As Integer) As Boolean
    <OperationContract()> _
    Function recursDisponible(ByVal Recurs As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As DataTable

End Interface

' Utilice un contrato de datos, como se ilustra en el ejemplo siguiente, para agregar tipos compuestos a las operaciones de servicio.
<DataContract()> _
Public Class CompositeType

    Private boolValueField As Boolean
    Private stringValueField As String

    <DataMember()> _
    Public Property BoolValue() As Boolean
        Get
            Return Me.boolValueField
        End Get
        Set(ByVal value As Boolean)
            Me.boolValueField = value
        End Set
    End Property

    <DataMember()> _
    Public Property StringValue() As String
        Get
            Return Me.stringValueField
        End Get
        Set(ByVal value As String)
            Me.stringValueField = value
        End Set
    End Property

End Class
